#include <bits/stdc++.h>

#define itn long long
#define int long long
//#define double long double
//#define endl '\n'
#define p_b push_back
#define fi first
#define se second
#define pii pair<int, int>
#define oo LLONG_MAX
#define elif else if

using namespace std;

int input()
{
    int x;
    cin>>x;
    return x;
}


int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

//        freopen("divisor.dat", "r", stdin);
//        freopen("prpr.txt", "w", stdout);

    int n;
    cin>>n;
    int a[n];
    vector<pii>ans;
    for(int i=0;i<n;i++)cin>>a[i];
    for(int i=0;i<n;i++)
    {
        int last=0;
        for(int j=0;j<n;j++)
        {
            if(j==n-1 or a[j]<a[j+1])
            {
                if(j>last)
                {
                    reverse(a+last, a+j+1);
                    ans.p_b({last+1, j+1});
                }
                last=j+1;
            }
        }
//        for(int j=0;j<n;j++)cout<<a[j]<<' ';cout<<endl;
    }
    cout<<ans.size()<<endl;
    for(auto i:ans)cout<<i.fi<<' '<<i.se<<endl;




}
